#include <stdio.h>
#include <stdlib.h>

#define MAXBC 127

#define TRACE

int main()
{
  char buf[MAXBC+1];
  float a, b, c, d, low, high, eps, y_low, y_high, x_med, y_med;

  /* lettura dei coefficienti */

  if (gets(buf) == NULL)
  {
    fprintf (stderr, "errore - non sono stati introdotti i coefficienti\n");
    exit (1);
  }
  if (sscanf(buf, "%f%f%f%f", &a, &b, &c, &d) != 4)
  {
    fprintf (stderr, "errore - non sono stati introdotti tutti i coefficienti\n");
    exit(1);
  }

  /* lettura dell'intervallo */

  if (gets(buf) == NULL)
  {
    fprintf (stderr, "errore - non e' stato introdotto l'intervallo\n");
    exit (2);
  }
  if (sscanf(buf, "%f%f", &low, &high) != 2)
  {
    fprintf (stderr, "errore - non sono stati introdotti i due estremi dell'intervallo\n");
    exit (2);
  }

  /* lettura della precisione */

  if (gets(buf) == NULL)
  {
    fprintf (stderr, "errore - non e' stata introdotta la precisione desiderata\n");
    exit (3);
  }
  if (sscanf(buf, "%f", &eps) != 1)
  {
    fprintf (stderr, "errore - non e' stata introdotta la precisione desiderata\n");
    exit (3);
  }

  /* verifica che la funzione abbia segno opposto agli estremi dell'intervallo */

  y_low = a * low * low * low + b * low * low + c * low + d;
  y_high = a * high * high * high + b * high * high + c * high + d;

  if (y_low * y_high >= 0)
  {
    fprintf (stderr, "errore - la funzione non ha segno opposto agli estremi dell'intervallo\n");
    exit (4);
  }

  /* ricerca dello zero */

  x_med = (low + high) / 2;
  y_med = a * x_med * x_med * x_med + b * x_med * x_med + c * x_med + d;

  while ((y_med * y_med ) > (eps * eps))
  {
#ifdef TRACE
    printf ("low=%f  high=%f  x_med=%f  y_med=%f\n", low, high, x_med, y_med);
#endif

    /* scelta del sottointervallo su cui continuare la ricerca */

    if (y_med * y_high < 0)
    {
      low = x_med;
      y_low = a * low * low * low + b * low * low + c * low + d;
    }
    else
    {
      high = x_med;
      y_high = a * high * high * high + b * high * high + c * high + d;
    }

    /* punto medio del sottointervallo */

    x_med = (high + low) / 2;
    y_med = a * x_med * x_med * x_med + b * x_med * x_med + c * x_med + d;
  }

  printf ("x0=%f e' uno zero della funzione (con margine di errore %f)\n", x_med, eps);
  printf ("y(x0)=%f\n", y_med);

  return 0;
}
